<template>
  <!-- Formulaire -->
  <form v-if="!formSubmitedIsOK">
    <b-alert v-model="showDismissibleAlert" variant="danger" dismissible>{{ globalError }}</b-alert>
    <div class="form-group" v-for="champ in contactFields" :key="champ.index">
      <label :for="champ.id">
        {{ champ.libelle }}
        <span v-if="champ.required">*</span>
      </label>
      <span v-if="champ.error != ''">{{ champ.error }}</span>
      <input v-if="champ.type !== 'textarea'" :type="champ.type" :ref="champ.id" class="form-control" :id="champ.id" :placeholder="champ.placeHolder" v-model="champ.value" />
      <textarea v-else class="form-control" :type="champ.type" rows="3" v-model="champ.value"></textarea>
    </div>

    <div class="alert alert-danger" role="alert"><strong>Prévoir captcha calcul </strong></div>

    <button type="button" class="btn btn-warning" @click="submitForm()">Envoyer</button>
  </form>
  <div v-else>
    <!-- Message de confirmation d'envoi de formulaire-->
    <h3>Le formulaire a été envoyé</h3>
  </div>
</template>

<script>
const FOLDER_UPLOAD = process.env.VUE_APP_URL_UPLOAD_FOLDER;
export default {
  props: ["contactFields"],
  beforeMount: function() {
    this.fetchDataConfig("coords");
  },
  data() {
    return {
      globalError: "",
      loader: false,
      emailAdmin: null,
      errorForm: false,
      formSubmitedIsOK: false,
      showDismissibleAlert: false
    };
  },
  methods: {
    fetchDataConfig(name) {
      this.$axios
        .get(this.$urls.URL_FETCH_DATA_CONFIG_SITE + name)
        .then(response => {
          let coords = JSON.parse(response.data.config.data);
          this.emailAdmin = coords[0].contenu[0].value;
        })
        .catch(error => {
          console.log("error", error);
          // this.dialogLoader = false;
        });
    },
    checkForm() {
      this.contactFields.forEach(field => {
        if (field.value == "" && field.required == true) {
          field.error = "Ce champs est obligatoire";
          this.errorForm = true;
        }
      });
      //
    },
    submitForm() {
      // vérification des champs du formulaire
      this.errorForm = false;
      this.checkForm();

      if (this.errorForm == false) {
        // setup des datas du formulaire
        let formData = this.setDataForm();

        // envoi du mail
        this.sendMail(formData);
      }
    },
    setDataForm() {
      let emailsTO = [this.emailAdmin];
      let emailsCC = [];
      let emailsBCC = [];
      // * Notes : Avec mailtrap on est limité à 2 emails/secondes
      let emailSender = this.contactFields[2].value;
      // let emailSender = this.formContact.email.value;
      let formData = new FormData();
      let medias = this.handleMedias(this.contactFields);
      let jsonFormContact = JSON.stringify(this.contactFields);

      medias.forEach(media => {
        formData.append("medias[]", media);
      });

      emailsTO.forEach(emailTO => {
        formData.append("emailsTO[]", emailTO);
      });

      emailsCC.forEach(emailCC => {
        formData.append("emailsCC[]", emailCC);
      });

      emailsBCC.forEach(emailBCC => {
        formData.append("emailsBCC[]", emailBCC);
      });

      formData.append("folderUpload", FOLDER_UPLOAD);
      formData.append("emailSender", emailSender);
      formData.append("dataForm", jsonFormContact);
      formData.append("subject", "Message provenant de votre site");

      return formData;
    },
    handleMedias(formContact) {
      // traitement pièce jointes
      let filesToUpload = [];
      let files = [];
      for (let [key, objChamp] of Object.entries(formContact)) {
        for (let [k, v] of Object.entries(objChamp)) {
          if (v == "file") {
            files.push(objChamp.id);
          }
        }
      }
      files.forEach(el => {
        filesToUpload.push(this.$refs[el][0].files[0]);
      });

      return filesToUpload;
    },
    handleServerErrors(response) {
      if (response.data.data == "Email OK") {
        this.formSubmitedIsOK = true;
      }

      if (response.data.message) {
        let errorMsg = [];
        for (var i in response.data.message) {
          errorMsg.push([i, response.data.message[i]]);
        }
        this.globalError = errorMsg[0][1][0];
        this.showDismissibleAlert = true;
      }
    },
    sendMail(formData) {
      this.globalError = "";
      const config = {
        headers: { "Content-Type": "multipart/form-data" }
      };

      this.$axios
        .post(this.$urls.URL_EMAIL_CONTACT_UPLOAD, formData, config)
        .then(response => {
          this.handleServerErrors(response);
        })
        .catch(error => {
          console.log("message", error);
          this.globalError = error;
          this.showDismissibleAlert = true;
        });
    }
  }
};
</script>
